!
! Module: oal_aux
!
! Authors: Masaaki Sakano - SSC/LUX
!          
! Description: Some auxiliary functions/subroutines for uses with oal.
! 
! Comments: TODO:
! 
! $Id: oal_aux.f90,v 1.6 1998/05/27 13:45:39 gvacanti Exp $
!- 
module oal_aux

  use oal
  use errorHandling

  implicit none 

  private 

  public printODFProposal

contains 

  !---------------------------------------------------------------------
  subroutine printODFProposal(proposalInfo, printHeader)
  !---------------------------------------------------------------------
  ! print the ODF information to STDOUT for debugging etc.
  ! This subroutine is moved from rgssources_mod.f90 (Ver.6.1.1)
  !
  ! USAGE (example):
  !   use oal_aux
  !   type(ProposalInfoType) :: proposalInfo
  !   call OAL_proposalInfo(proposalInfo)	! Get the ODF proposalInfo
  !   call printODFProposal(proposalInfo)

    implicit none 

    type(ProposalInfoType), intent(in) :: proposalInfo  ! typedef from oal
    logical, intent(in), optional :: printHeader	! Default is .true.
    logical :: printHeaderLoc

    !-------------------------------------------------------------------
    ! Start:

    if (present(printHeader)) then
      printHeaderLoc = printHeader
    else
      printHeaderLoc = .true.	! Default
    end if

    if (printHeaderLoc) &
    write(*, *) '=== ODF proposal information ==='
    ! from /packages/oal/doc/oalsources/oalexample.f90
    write(*, *) 'GO name                    : ', trim(proposalInfo%GoName)
    write(*, *) 'GO institute               : ', trim(proposalInfo%GoInstitute)
    write(*, *) 'GO address                 : ', trim(proposalInfo%GoAddress)
    write(*, *) 'GO e-mail                  : ', trim(proposalInfo%GoEmail)
    write(*, *) 'AO                         : ', proposalInfo%AO
    write(*, *) 'science type               : ', proposalInfo%scienceType
    write(*, *) 'target name                : ', trim(proposalInfo%targetName)
    write(*, *) 'target RA                  : ', proposalInfo%targetRa
    write(*, *) 'target Dec                 : ', proposalInfo%targetDec
    write(*, *) 'duration of observation [s]: ', proposalInfo%obsDuration
    write(*, *) 'boresight RA               : ', proposalInfo%boresightRa
    write(*, *) 'boresight Dec              : ', proposalInfo%boresightDec
    write(*, *) 'position angle constr (lo) : ', proposalInfo%posAngleConstLo
    write(*, *) 'position angle constr (hi) : ', proposalInfo%posAngleConstHi
    write(*, *) 'position angle orig. ref.  : ', proposalInfo%posAngleOrigRef
    write(*, *) 'EMOS1 priority             : ', proposalInfo%emos1Prio
    write(*, *) 'EMOS2 priority             : ', proposalInfo%emos2Prio
    write(*, *) 'EPN priority               : ', proposalInfo%epnPrio
    write(*, *) 'RGS1 priority              : ', proposalInfo%rgs1Prio
    write(*, *) 'RGS2 priority              : ', proposalInfo%rgs2Prio
    write(*, *) 'OM priority                : ', proposalInfo%omPrio

  end subroutine printODFProposal

  !---------------------------------------------------------------------
  subroutine template
  !---------------------------------------------------------------------

    implicit none

    !-------------------------------------------------------------------
    ! Start

  end subroutine template

end module oal_aux
