!
! Program: testdss_aux
!
! Authors:  Masaaki Sakano - SSC/LUX
!          
! Description: Test dss_aux module.
! 
! Comments:
!   This _was_ used mainly in order to detect the point causing SegFault.
!
!-
program testdss_aux
  use cal	! for convertPiToEeV (and CAL_setState)
  use dal
  use dss	! for RangeT and BoundT
  use errorhandling
  ! use test_utils	! for isNearlyEqual()
  use dss_aux
  use dss_ranges_aux	! for copyRanges
  use exposure	! for convertPiToEeV

  implicit none

  integer(int32), parameter :: maxRepM = 1, maxRepMs = 1
  !integer(int32), parameter :: maxRepM = 100	! for (memory) stress test.
  ! It takes ???sec ish with aral for maxRep = 100000 (in 2008).
  integer(int32) :: iM !, nM

  type(DataSetT) :: inSetM
  type(BlockT) :: inBlockM
  type(ArrayT) :: imageArrayM
  type(DssT) :: dssPointerM

  type(RangeT), pointer :: piRangesM(:) => null()

  character(2), parameter :: axisNameM = 'PI'
  !logical :: thereAreConstraintsM, noCompObeysConstraintsM, isNewRangeChainM
  logical :: isNewRangeChainM
  !type(dssCompSubsetType), pointer :: compSubsetsM(:) => null()
  type(DScompT) :: dssCompM
  type(RangeT), pointer :: compRangesM(:) => null()
  !integer :: compNum
  integer :: numCompsM = 12, compNumM, numCompSubsetsM !, compSubsetNumM
  logical :: testFlag = .false.

  print *, 'Test test_addNewCompNumToSubset()'
  do iM=1,maxRepM
        call test_addNewCompNumToSubset
  end do

    print *, 'Test test_numFiltersOfAxis()'
    do iM=1,maxRepMs
      !do iM=1,1000
      call test_numFiltersOfAxis
    end do

    inSetM = dataSet('outfiles/pn_2000.ds', READ)
    inBlockM = block(inSetM, 0, READ)
    imageArrayM = array(inSetM, 0, READ)

    if (hasDss(imageArrayM)) then ! in ssclib/dss_aux
      dssPointerM = dataSubspace(inBlockM)

      print *, 'Test manually readRanges()'
      print *, 'numComps = ', dssComponents(dssPointerM)	! == 12

      do iM=1,maxRepM
        do compNumM = 0, 11	! (0 .. (12 - 1))
          dssCompM = dssComponent(dssPointerM, compNumM)
          exit
        end do
        numCompSubsetsM = 0
        !allocate(compSubsetsM(numCompSubsetsM))
        do compNumM = 0, numCompsM - 1
          dssCompM = dssComponent(dssPointerM, compNumM)

         !print *, 'compNum = ', compNumM
          !call readRangesComp(dssComp, axisName, compRanges)
          !call readRanges_Test(dssComp, axisName, compRanges)
if (testFlag) print *,'compNumM = ', compNumM
          !call readRanges(dssCompM, 'PI', compRangesM)
          call readRanges_Tst(dssCompM, compRangesM)
         !print *, ' compRanges(', size(compRangesM), ') = '&
         !     , compRangesM(1)%lower%value, ',', compRangesM(1)%upper%value

          ! Does it have a range chain the same as any of the previous range chains?
          isNewRangeChainM = .true. ! default

          !if (isNewRangeChainM) then ! make a new component subset:
!        call addNewCompSubset(compSubsetsM, numCompSubsetsM, compRangesM, compNumM)
          !else ! it is the same ranges as a previous block
          !  call addNewCompNumToSubset(compSubsetsM(numCompSubsetsM)%compNums&
          !    , compNumM)
          !end if

          deallocate(compRangesM)
        end do
        !call deallocateDssCompSubset(compSubsetsM(1))
        !deallocate(compSubsetsM)
      end do	! do iM=1,maxRepM


    print *, 'Test readRanges()'
      do iM=1,maxRepM
        call readRanges(dssPointerM, 'PI', piRangesM) ! in ssclib/dss_aux
      end do
        call dssRelease(dssPointerM)
    end if	! if (hasDss(imageArrayM)) then

    call release(inSetM)

contains

  !---------------------------------------------------------------------
  subroutine get_dssPointer(inSet, dssPointer)
  !---------------------------------------------------------------------
    
    implicit none

    type(DataSetT), intent(out) :: inSet
    type(DssT), intent(out) :: dssPointer
    type(BlockT) :: inBlock
    type(ArrayT) :: imageArray

    inSet = dataSet('outfiles/pn_2000.ds', READ)
    inBlock = block(inSet, 0, READ)
    imageArray = array(inSet, 0, READ)

    !if (hasDss(imageArray)) then ! in ssclib/dss_aux
      dssPointer = dataSubspace(inBlock)
    !else
    !  call error('noDssInBlock')
    !end if

  end subroutine get_dssPointer


  !---------------------------------------------------------------------
  subroutine test_numFiltersOfAxis
  !---------------------------------------------------------------------
    
    implicit none

    type(DataSetT) :: inSetS
    type(BlockT) :: inBlockS
    type(DssT) :: dssPointerS
    type(DScompT) :: dssCompS

    integer :: iS, jS ! = 5

    inSetS = dataSet('outfiles/pn_2000.ds', READ)
    inBlockS = block(inSetS, 0, READ)
    dssPointerS = dataSubspace(inBlockS)
    do iS = 0, 11
      ! print *, 'i = ', i
      dssCompS = dssComponent(dssPointerS, iS)
      jS = numFiltersOfAxis(dssCompS, 'PI')
!print *,'here_na0 = ', iS, jS
      !kS = numFiltersOfAxis_Tst(dssCompS, 'PI')
    end do
!print *,'here_na1'
    call dssRelease(dssPointerS)
!print *,'here_na2'
    call release(inSetS)
!print *,'here_na3'

  end subroutine test_numFiltersOfAxis


  !---------------------------------------------------------------------
  integer function numFiltersOfAxis_Tst(dssComp, axisName)
  !---------------------------------------------------------------------
  ! Moved numFiltersOfAxis to here and tidied it up.

    implicit none

    type(DScompT), intent(in) :: dssComp
    character(*),  intent(in) :: axisName

    integer :: filtNum, numFilters
    type(DSfilterT) :: filter

    !-------------------------------------------------------------------
    ! Start

    numFiltersOfAxis_Tst = 0  ! default

    numFilters = dssFilters(dssComp)
    do filtNum = 0, numFilters - 1
      filter = dssFilter(dssComp, filtNum)
      if (dssFilterName(filter) .eq. axisName)&
        numFiltersOfAxis_Tst = numFiltersOfAxis_Tst + 1 
    end do

  end function numFiltersOfAxis_Tst

  !---------------------------------------------------------------------
  subroutine readRanges_Tst(dssComp, compRanges)
  !---------------------------------------------------------------------
  ! NOTE that the pointer compRanges() should be deallocated after use.

    type(DScompT), intent(in) :: dssComp
    type(RangeT), pointer     :: compRanges(:)	! intent(out)
    character(2),  parameter  :: axisName = 'PI'

    integer :: filtNum, nSize
    type(DSfilterT) :: filter
    type(RangeT),  allocatable :: ranges(:)  !, tempRangeChain(:)
    !character(20) :: dssFilterTypeStr

    !-------------------------------------------------------------------
    ! Start

    allocate(compRanges(1))
    compRanges%lower%type = UNDEFINED
    compRanges%upper%type = UNDEFINED
    compRanges%lower%value = 0.0 ! unnecessary, but I don't
    compRanges%upper%value = 0.0 ! like to leave them hanging.

  if (numFiltersOfAxis(dssComp, axisName) .le. 0) return

    !do filtNum = 0, dssFilters(dssComp) - 1
    do filtNum = 4, 4
      filter = dssFilter(dssComp, filtNum)
 !   if (dssFilterName(filter) .ne. axisName) cycle

 !     if (dssFilterType(filter) .eq. RANGEFILTERT) then
        call dssFilterRangesSize(filter,nSize)
      	allocate(ranges(0:nSize-1))
        ranges = dssRanges(filter)
        
!        tempRangeChain => andRangesPair(compRanges, ranges)
!        deallocate(compRanges)
!        deallocate(ranges)
!        compRanges => tempRangeChain

if (testFlag) print *,'filtNum = ', filtNum
!call andRanges(ranges, compRanges, logical(.true., bool))	! To guarantee the correct structure.
!call andRanges(ranges, compRanges)	! To guarantee the correct structure.
compRanges = ranges
!call dumpRanges(ranges)
!call dumpRanges(compRanges)
deallocate(ranges)
!call dumpRanges(compRanges)

 !     else
 !       allocate(compRanges(0))
 !       dssFilterTypeStr = filterTypeToStr(dssFilterType(filter))
 !       call warning('badDssFilterType', "ssclib:readRangesComp: A filter of type "&
 !         //trim(dssFilterTypeStr)//" on the axis "//trim(axisName)&
 !         //" was detected. I couldn't read the information from this: &
 !         &I can only read the information in RANGEFILTERT filters.")
 !     end if
!nullify(filter%ptr)
    end do

  end subroutine readRanges_Tst


  !---------------------------------------------------------------------
  subroutine test_addNewCompNumToSubset
  !---------------------------------------------------------------------
    
    implicit none

    integer, pointer    :: compNums(:)
    integer, parameter :: compNum = 99

    allocate(compNums(2))
    compNums(1)=3
    compNums(2)=6

    call addNewCompNumToSubset(compNums, compNum)

    if ((compNums(1) .ne. 3) .or. &
        (compNums(2) .ne. 6) .or. &
        (compNums(3) .ne. 99)) then
      write(errstr, *) "Inconsistent compNums = ", compNums
      call error("InconsistentCompNums")
    end if

  end subroutine test_addNewCompNumToSubset


  ! Copied from dss_aux as it is private
  !---------------------------------------------------------------------
  subroutine addNewCompSubset(compSubsets, numCompSubsets, ranges, compNum)
  !---------------------------------------------------------------------

    implicit none

    type(dssCompSubsetType), pointer   :: compSubsets(:)
    integer,             intent(inout) :: numCompSubsets
    type(RangeT),        intent(in)    :: ranges(:)
    integer,             intent(in)    :: compNum

    type(dssCompSubsetType), pointer :: tempCompSubsets(:) => null()
    integer :: i

    !-------------------------------------------------------------------
    ! Start

    allocate(tempCompSubsets(numCompSubsets))
    call copyCompSubsets(compSubsets, tempCompSubsets)
    do i = lbound(compSubsets, 1), ubound(compSubsets, 1)
      call deallocateDssCompSubset(compSubsets(i))
    end do
    deallocate(compSubsets)

    numCompSubsets = numCompSubsets + 1
    allocate(compSubsets(numCompSubsets))

    call copyCompSubsets(tempCompSubsets&
      , compSubsets(:numCompSubsets-1))
    do i = lbound(tempCompSubsets, 1), ubound(tempCompSubsets, 1)
      call deallocateDssCompSubset(tempCompSubsets(i))
    end do
    deallocate(tempCompSubsets)

    call copyRanges(ranges, compSubsets(numCompSubsets)%ranges)
    allocate(compSubsets(numCompSubsets)%compNums(1))
    compSubsets(numCompSubsets)%compNums(1) = compNum

  end subroutine addNewCompSubset

  ! Copied from dss_aux as it is private
  !---------------------------------------------------------------------
  subroutine addNewCompNumToSubset(compNums, compNum)
  !---------------------------------------------------------------------
  ! Increse the array size of compNums by 1, with the component compNum

    implicit none

    integer, pointer    :: compNums(:)
    integer, intent(in) :: compNum

    integer :: numComps
    integer, allocatable :: tempCompNums(:)

    !-------------------------------------------------------------------
    ! Start

    numComps = size(compNums)
    allocate(tempCompNums(numComps))
    tempCompNums = compNums
    deallocate(compNums)
    numComps = numComps + 1
    allocate(compNums(numComps))
    compNums(:numComps-1) = tempCompNums
    compNums(numComps) = compNum

  end subroutine addNewCompNumToSubset


  ! Copied from dss_aux as it is private
  !---------------------------------------------------------------------
  subroutine copyCompSubsets(inCompSubsets, outCompSubsets)
  !---------------------------------------------------------------------

    implicit none

    type(dssCompSubsetType), intent(in)  :: inCompSubsets(:)
    type(dssCompSubsetType), intent(out) :: outCompSubsets(size(inCompSubsets))

    integer :: numCompSubsets, compSubsetNum

    !-------------------------------------------------------------------
    ! Start

    numCompSubsets = size(inCompSubsets)
    do compSubsetNum = 1, numCompSubsets
      outCompSubsets(compSubsetNum)&
        = copyCompSubset(inCompSubsets(compSubsetNum))
    end do

  end subroutine copyCompSubsets

  ! Copied from dss_aux as it is private
  !---------------------------------------------------------------------
  function copyCompSubset(inCompSubset) result(outCompSubset)
  !---------------------------------------------------------------------

    implicit none

    type(dssCompSubsetType), intent(in) :: inCompSubset
    type(dssCompSubsetType)             :: outCompSubset

    !-------------------------------------------------------------------
    ! Start

    call copyRanges(inCompSubset%ranges, outCompSubset%ranges)
    allocate(outCompSubset%compNums(size(inCompSubset%compNums)))
    outCompSubset%compNums = inCompSubset%compNums

  end function copyCompSubset


  !---------------------------------------------------------------------
  subroutine test_convertPiToEeV
  !---------------------------------------------------------------------
    
    implicit none

    call message(AppMsg, Sparse, 'Try with EMOS2...')
    call CAL_setState(instrument=EMOS2)
    call test_convertPiToEeV_core	! 8 tests including 18 assertions

    call message(AppMsg, Sparse, 'Try with EPN...')
    call CAL_setState(instrument=EPN)
    call test_convertPiToEeV_core	! 8 tests including 18 assertions

  end subroutine test_convertPiToEeV


  !---------------------------------------------------------------------
  subroutine test_convertPiToEeV_core
  !---------------------------------------------------------------------
  ! Note! The cal state should be set for instrument before this routine
  ! is called.

    implicit none

    type(BoundT) :: piBoundsLower(2), piBoundsUpper(2), EeVBounds(2)
    type(RangeT) :: piRange, EeVrange
    type(RangeT) :: piRanges(2), EeVranges(2)
    real(double) :: piValues(2)  = (/ 30, 300 /), EeVValues(2)
    real(single) :: piValuesS(2) = (/ 30, 300 /), EeVValuesS(2)

    !-------------------------------------------------------------------
    ! Start

    piBoundsLower%type = INCLUSIVE	! defined in dsslib
    piBoundsUpper%type = INCLUSIVE	! defined in dsslib
    piBoundsLower(1)%value = 2
    piBoundsUpper(1)%value = 20
    piBoundsLower(2)%value = 200
    piBoundsUpper(2)%value = 2000

    !! Test of convertPiBoundToEeV(piBound)
    EeVBounds(1) = convertPiToEeV(piBoundsLower(1))	! convertPiBoundToEeV(piBound)
    if ((EeVBounds(1)%type  .ne. piBoundsLower(1)%type)  .or. &
        (EeVBounds(1)%value .ne. piBoundsLower(1)%value)) then
      write(errstr, *) "Inconsistent EeVBound = (", EeVBounds%type &
           , ",", EeVBounds%value, ")"
      call error("InconsistentEeVBound")
    end if

    !! Test of convertPiBoundsToEeV(piBounds)
    EeVBounds = convertPiToEeV(piBoundsLower)	! convertPiBoundsToEeV(piBounds)
    if ((EeVBounds(1)%type  .ne. piBoundsLower(1)%type)  .or. &
        (EeVBounds(1)%value .ne. piBoundsLower(1)%value) .or. &
        (EeVBounds(2)%type  .ne. piBoundsLower(2)%type)  .or. &
        (EeVBounds(2)%value .ne. piBoundsLower(2)%value)) then
      write(errstr, *) "Inconsistent EeVBounds..."
      call error("InconsistentEeVBounds")
    end if

    !! Test of convertPiRangeToEeV(piRange)
    piRange%lower = piBoundsLower(1)
    piRange%upper = piBoundsUpper(1)
    EeVrange = convertPiToEeV(piRange)	! = convertPiRangeToEeV(piRange)
    if ((EeVrange%lower%value .ne. piRange%lower%value) .or. &
        (EeVrange%upper%value .ne. piRange%upper%value)) then
      write(errstr, *) "Inconsistent EeVrange = (", EeVrange%lower%value &
           , ",", EeVrange%upper%value, ")"
      call error("InconsistentEeVrange")
    end if

    !! Test of convertPiRangesToEeV(piRange)
    piRanges%lower = piBoundsLower
    piRanges%upper = piBoundsUpper
    EeVranges = convertPiToEeV(piRanges)	! = convertPiRangesToEeV(piRanges)
    if ((EeVranges(1)%lower%value .ne. piRanges(1)%lower%value) .or. &
        (EeVranges(1)%upper%value .ne. piRanges(1)%upper%value) .or. &
        (EeVranges(2)%lower%value .ne. piRanges(2)%lower%value) .or. &
        (EeVranges(2)%upper%value .ne. piRanges(2)%upper%value)) then
      write(errstr, *) "Inconsistent EeVranges..."
      call error("InconsistentEeVranges")
    end if

    !! Test of convertPiToEeVScalarSingle(piValue)
    EeVValuesS(1) = convertPiToEeV(piValuesS(1))	! = convertPiToEeVScalarSingle(piValue)
    if (EeVValuesS(1) .ne. piValuesS(1)) then
      write(errstr, *) "Inconsistent EeVValueS = ", EeVValuesS(1), " (!= ", piValuesS(1), ")"
      call error("InconsistentEeVValueSingle")
    end if

    !! Test of convertPiToEeVScalarDouble(piValues)
    EeVValues(1) = convertPiToEeV(piValues(1))	! = convertPiToEeVScalarDouble(piValues)
    if (EeVValues(1) .ne. piValues(1)) then
      write(errstr, *) "Inconsistent EeVValue = ", EeVValues(1), " (!= ", piValues(1), ")"
      call error("InconsistentEeVValueDouble")
    end if

    !! Test of convertPiToEeVVectorSingle(piValuesS)
    EeVValuesS = convertPiToEeV(piValuesS)	! = convertPiToEeVVectorSingle(piValues)
    if ((EeVValuesS(1) .ne. piValuesS(1)) .or. &
        (EeVValuesS(2) .ne. piValuesS(2))) then
      write(errstr, *) "Inconsistent EeVValuesSingle..."
      call error("InconsistentEeVValuesSingle")
    end if

    !! Test of convertPiToEeVVectorDouble(piValues)
    EeVValues = convertPiToEeV(piValues)	! = convertPiToEeVVectorDouble(piValues)
    if ((EeVValues(1) .ne. piValues(1)) .or. &
        (EeVValues(2) .ne. piValues(2))) then
      write(errstr, *) "Inconsistent EeVValuesDouble..."
      call error("InconsistentEeVValuesDouble")
    end if

  end subroutine test_convertPiToEeV_core

end program testdss_aux
